#ifndef DEFINE_FLAGS
#define DEFINE_FLAGS


#include <math.h>



class flags
{

private:
	
	inline unsigned int bin(const unsigned int i)
	{
		if(i == 0)
			return 0;
		else
			return pow(2.0f, (int)i-1);
	}

public:

	unsigned int value;
	
	
	flags()
	{
		value = 0;
	}
	
	flags(unsigned int new_value)
	{
		value = new_value;
	}
	
	void operator=(flags new_flags)
	{
		value = new_flags.value;
	}
	
	void operator=(unsigned int new_value)
	{
		value = new_value;
	}
	

	void operator+=(const unsigned int i)
	{
		value |= bin(i);
	}
	
	void operator-=(const unsigned int i)
	{
		value -= bin(i);
	}
	
	bool operator&(const unsigned int wanted)
	{
		return (value & bin(wanted));
	}
	
	bool operator==(unsigned int wanted_value)
	{
		return (value == wanted_value);
	}
	
};

#endif
