#ifndef WEAPONS_HPP
#define WEAPONS_HPP



enum TURRET_TYPES
{
	TURRET_TYPE_LASER=0,
	TURRET_TYPE_GUN
};


enum DOOR_TYPES
{
	DOOR_TYPE_VERTICAL=0,
	DOOR_TYPE_HORIZONTAL
};



struct EXPLORER_ENTITY
{
	bool used;
	vec2 pos;
	EXPLORER_ENTITY() { used = false; }
};



struct TURRET : EXPLORER_ENTITY
{
	int type;
	bool dead;
	int life;
	float timer;
	float timer_respawn;
	int damage_taken;
	float damage_taken_tick;
	bool frozen;
	float frozen_timer;
};



struct MINE : EXPLORER_ENTITY
{
	bool dead;
	float timer_respawn;
};



struct TRAP : EXPLORER_ENTITY
{
	float timer;
};



struct DOOR : EXPLORER_ENTITY
{
	int type;
	class LASER_DOOR * laser;
	bool create_laser;
};



enum
{
	MAX_TURRETS=256,
	MAX_MINES=256,
	MAX_TRAPS=256,
	MAX_DOORS=128
};



#endif
