#include <string.h> //strlen()
#include <sstream> //files (getline)
#include <fstream> //files

#include <engine/e_server_interface.h> //server_tick(), server_tickspeed()
#include <engine/e_config.h> //map

#include <game/server/gamecontext.hpp>
#include "exp.hpp"



void GAMECONTROLLER_EXP::tick_save()
{
	//SAVE THE GAMES
	for(int fi = 0; fi < cur_flag+1; fi++)
	{
		FLAG * f = NULL;
		if(fi == cur_flag)
			f = flag_end;
		else
			f = flags_cp[fi];
		if(!f) //if there isn't flag end
			continue;
		
		CHARACTER * close_characters[MAX_CLIENTS];
		int num = game.world.find_entities(f->pos, 16.0f, (ENTITY**)close_characters, MAX_CLIENTS, NETOBJTYPE_CHARACTER);
		for(int i = 0; i < num; i++)
		{
			if(!close_characters[i]->alive || close_characters[i]->player->is_bot() || close_characters[i]->player->team == -1)
				continue;
			int id = close_characters[i]->player->client_id;
			
			if(fi == cur_flag)
			{
				//END
				if(!boss.exist || game.players[id]->game_exp.boss_killer)
					stop_client(id);
			}
			else
			{
				//REGEN
				if((float)server_tick() > close_characters[i]->player->game_exp.regen_timer + tuning.regen_timer*server_tickspeed())
				{
					if(close_characters[i]->health < 10) //regen health
					{
						close_characters[i]->health++;
						close_characters[i]->player->game_exp.regen_timer = (float)server_tick();
					}
					else if(close_characters[i]->armor < close_characters[i]->player->game_exp.armor_max) //regen armor
					{
						close_characters[i]->armor++;
						close_characters[i]->player->game_exp.regen_timer = (float)server_tick();
					}
					else //regen ammo
					{
						int wid = close_characters[i]->active_weapon;
						if(close_characters[i]->weapons[wid].ammo != -1)
						{
							int maxammo = data->weapons.id[wid].maxammo;
							if(close_characters[i]->weapons[wid].ammo < maxammo)
							{
								close_characters[i]->weapons[wid].ammo++;
								close_characters[i]->player->game_exp.regen_timer = (float)server_tick();
							}
						}
					}
				}
				
				//SAVE
				if((float)server_tick() - close_characters[i]->player->game_exp.save_timer > 0)
				{
					close_characters[i]->player->game_exp.last_flag = fi+1;
					save_client(id);
				}
			}
		}
	}
}





void GAMECONTROLLER_EXP::save_client(int id)
{
	update_game(id);
	
	std::fstream save_file;
	char filename[256];
	get_filename(id, filename);
	save_file.open(filename, std::ios::out);
	
	save_file	<< game.players[id]->game_exp.last_flag-1			<< std::endl
				<< game.players[id]->game_exp.armor_max				<< std::endl
				<< game.players[id]->game_exp.weapons.value			<< std::endl
				<< game.players[id]->game_exp.kills					<< std::endl
				<< game.players[id]->game_exp.time					<< std::endl
				<< game.players[id]->game_exp.items.lives			<< ' '
				<< game.players[id]->game_exp.items.minor_potions	<< ' '
				<< game.players[id]->game_exp.items.greater_potions	<< std::endl;
	
	save_file.close();
	
	game.send_chat_target(id, "Game saved.");
	game.players[id]->game_exp.save_timer = (float)server_tick() + 5.0f*server_tickspeed();
}


void GAMECONTROLLER_EXP::load_client(int id)
{
	std::string dflag;
	std::string darmor;
	std::string dkills;
	std::string dweapons;
	std::string dtime;
	std::string ditems;
	int flag;
	int armor;
	int kills;
	flags weapons;
	int time;
	ITEMS items;
	
	std::fstream read_file;
	char filename[256];
	get_filename(id, filename);
	read_file.open(filename, std::ios::in);
	if(read_file.fail())
	{
		start_client(id);
		game.send_chat_target(id, "Game started.");
		return;
	}
	
	if(read_file.eof())
	{
		restart_client(id);
		return;
	}
	std::getline(read_file, dflag);
	flag = atof(dflag.c_str());
	
	if(!flags_cp[flag] || read_file.eof())
	{
		restart_client(id);
		return;
	}
	std::getline(read_file, darmor);
	armor = atof(darmor.c_str());
	
	if(read_file.eof())
	{
		restart_client(id);
		return;
	}
	std::getline(read_file, dweapons);
	weapons = atof(dweapons.c_str());
	
	if(read_file.eof())
	{
		restart_client(id);
		return;
	}
	std::getline(read_file, dkills);
	kills = atof(dkills.c_str());
	
	if(read_file.eof())
	{
		restart_client(id);
		return;
	}
	std::getline(read_file, dtime);
	time = atof(dtime.c_str());
	
	if(read_file.eof())
	{
		restart_client(id);
		return;
	}
	std::getline(read_file, ditems);
	items.lives				= split((char *)ditems.c_str(), 0);
	items.minor_potions		= split((char *)ditems.c_str(), 1);
	items.greater_potions	= split((char *)ditems.c_str(), 2);
	
	read_file.close();
	
	game.players[id]->kill_character(WEAPON_GAME);
	game.players[id]->load_game(flags_cp[flag]->pos, flag+1, kills, time, armor, weapons, items, false, false);
	game.players[id]->game_exp.enter_tick = server_tick();
	game.players[id]->game_exp.save_timer = (float)server_tick() + 5.0f*server_tickspeed();
}


void GAMECONTROLLER_EXP::restart_client(int id)
{
	char filename[256];
	get_filename(id, filename);
	remove(filename);
	start_client(id);
	game.send_chat_target(id, "Game restarted.");
}


void GAMECONTROLLER_EXP::start_client(int id)
{
	game.players[id]->kill_character(WEAPON_GAME);
	ITEMS items; items.lives = 0; items.minor_potions = 0; items.greater_potions = 0;
	game.players[id]->load_game(spawn_points[1][0], 0, 0, 0, 0, flags(0), items, false, false);
	game.players[id]->game_exp.enter_tick = server_tick();
	send_items(id);
}


void GAMECONTROLLER_EXP::stop_client(int id)
{
	update_game(id);
	int min = game.players[id]->game_exp.time / 60;
	int sec = game.players[id]->game_exp.time % 60;
	char buf[512];
	str_format(buf, sizeof(buf), "%s finished in %d minutes %d seconds with %d kills. Good Game !", server_clientname(id), min, sec, game.players[id]->game_exp.kills);
	game.send_chat_target(-1, buf);
	
	bool got_freezer = false;
	if(game.players[id]->game_exp.weapons & WEAPON_FREEZER)
		got_freezer = true;
	
	restart_client(id);
	
	if(got_freezer)
		game.players[id]->get_weapon(WEAPON_FREEZER);
}



void GAMECONTROLLER_EXP::update_game(int id)
{
	int diff_tick = server_tick() - game.players[id]->game_exp.enter_tick;
	game.players[id]->game_exp.time += (int) ( diff_tick / (float)server_tickspeed() );
	game.players[id]->game_exp.enter_tick = server_tick();
	game.players[id]->game_exp.kills = game.players[id]->score;
}



void GAMECONTROLLER_EXP::get_filename(int id, char buffer[256])
{
	char ip[16];
	server_getip(id, ip);
	str_format(buffer, 256, "database/%s@%s.dtb", ip, config.sv_map);
}





int split(char * line, int index)
{
	char num[8] = "";
	int cur_index = 0;
	int cur_chiffre = 0;
	for(unsigned int i = 0; i < strlen(line)+1; i++)
	{
		if(line[i] == ' ' || i == strlen(line))
		{
			if(index == cur_index)
				return atof(num);
			cur_index++;
			cur_chiffre = 0;
			str_copy(num, "", sizeof(num));
		}
		else
			num[cur_chiffre++] = line[i];
	}
	return 0;
}
