/* physics tuning */
MACRO_TUNING_PARAM(ground_control_speed, 10.0f)
MACRO_TUNING_PARAM(ground_control_accel, 100.0f / ticks_per_second)
MACRO_TUNING_PARAM(ground_friction, 0.5f)
MACRO_TUNING_PARAM(ground_jump_impulse, 13.2f)
MACRO_TUNING_PARAM(air_jump_impulse, 12.0f)
MACRO_TUNING_PARAM(air_control_speed, 250.0f / ticks_per_second)
MACRO_TUNING_PARAM(air_control_accel, 1.5f)
MACRO_TUNING_PARAM(air_friction, 0.95f)
MACRO_TUNING_PARAM(hook_length, 380.0f)
MACRO_TUNING_PARAM(hook_fire_speed, 80.0f)
MACRO_TUNING_PARAM(hook_drag_accel, 3.0f)
MACRO_TUNING_PARAM(hook_drag_speed, 15.0f)
MACRO_TUNING_PARAM(gravity, 0.5f)

MACRO_TUNING_PARAM(velramp_start, 550)
MACRO_TUNING_PARAM(velramp_range, 2000)
MACRO_TUNING_PARAM(velramp_curvature, 1.4f)

/* weapon tuning */
MACRO_TUNING_PARAM(gun_curvature, 1.25f)
MACRO_TUNING_PARAM(gun_speed, 2200.0f)
MACRO_TUNING_PARAM(gun_lifetime, 2.0f)

MACRO_TUNING_PARAM(shotgun_curvature, 1.25f)
MACRO_TUNING_PARAM(shotgun_speed, 2750.0f)
MACRO_TUNING_PARAM(shotgun_speeddiff, 0.8f)
MACRO_TUNING_PARAM(shotgun_lifetime, 0.20f)

MACRO_TUNING_PARAM(grenade_curvature, 7.0f)
MACRO_TUNING_PARAM(grenade_speed, 1000.0f)
MACRO_TUNING_PARAM(grenade_lifetime, 2.0f)

MACRO_TUNING_PARAM(laser_reach, 800.0f)
MACRO_TUNING_PARAM(laser_bounce_delay, 150)
MACRO_TUNING_PARAM(laser_bounce_num, 1)
MACRO_TUNING_PARAM(laser_bounce_cost, 0)
MACRO_TUNING_PARAM(laser_damage, 5)

MACRO_TUNING_PARAM(player_collision, 1)
MACRO_TUNING_PARAM(player_hooking, 1)



//EXPlorer tunings
//	All timer/reload/lifespan tunings are in seconds.
//	If a timer is from a tuning, it will be set to "server_tick()", and it will be checked with "server_tick() > timer + tuning.timer*server_tickspeed()"
//	Else it will be set to "server_tick() + seconds*server_tickspeed()", and it will be checked with "server_tick() > timer"

//misc :
MACRO_TUNING_PARAM(respawn_timer, 20.0f)
MACRO_TUNING_PARAM(regen_timer, 1.0f)
MACRO_TUNING_PARAM(poison_timer, 1.0f)
MACRO_TUNING_PARAM(pickup_lifetime, 20.0f)

//turrets :
MACRO_TUNING_PARAM(turret_life, 20)
MACRO_TUNING_PARAM(turret_reload, 0.5f)
MACRO_TUNING_PARAM(turret_laser_damage, 3)
MACRO_TUNING_PARAM(turret_laser_radius, 160)

//boss :
MACRO_TUNING_PARAM(boss_life, 200)
MACRO_TUNING_PARAM(boss_distancelimit, 1000.0f)

//freezing :
MACRO_TUNING_PARAM(freezer_reload, 1.5f)
MACRO_TUNING_PARAM(freeze_timer, 2.5f)
